TeIDE
=====

TeIDE is an IDE based on Node.js and Polymer. It provides a clean interface without too many
complicated options, applying material design concepts.

It's currently in alpha stage, lacking some very fundamental features for a code editor such as:

* Ability to copy or delete files from the editor interface
* Basic refactoring tools like search/replace
* Autocomplete

The existence of TeIDE is heavily inspired by Jupyter Notebooks, but without the big emphasis in
interactivity and using a material design interface.


Installation
------------

Install via NPM

  ```bash
  npm install -g teide
  ```


Usage
-----

Simply invoke the globally installed node module

  ```bash
  teide
  ```

    
Why another IDE?
----------------

There is an abundance of IDEs, why create another one?

1. For large projects there are full-featured options like Visual Studio, IDEA, Eclipse
2. For small projects there is Atom, Visual Studio Code
3. For individual files there is Notepad++, Notepad2, Sublime

TeIDE tries to be a good fit for small projects. Other IDEs don't do well there because:

* The overhead is hard to justify (specially with the full-featured options)
* Sometimes they feel very sluggish
* They tend to be very Git-centric


Browser support
---------------

TeIDE has been developed and tested exclusively on Chrome. Any feature working in any other
browser is purely coincidental and unintended.


TODO
----

Here is a non-comprehensive list of issues that need to be addressed:
    
* Add tests
* Add ability to undo "cut"
* Auto-remove trailing spaces from lines
* Add file copy feature
* Add file delete feature
* Add search/replace feature
* Add ability to create file or folder structure from template
* Add status bar/panel to editor (bottom)
  - Add error reporting from all components to status panel
  - Add autosave status to the status panel
  - Add current column to the status panel
* Add action bar/panel to editor (right)
  - Add auto-handling of setup.py, MAKEFILE
        
And some known issues:
    
* Cursor positioning does not work properly on Windows
* web-animations-js fails to resolve due to npm-Polymer
  [bug](https://github.com/PolymerElements/neon-animation/issues/184)

For everything else, feel free to open an issue via Github.


License
-------

TeIDE is open source and restricted by the MIT license, please see the full
[LICENSE](https://omtinez.mit-license.org/) text for details.


What does "TeIDE" mean?
-----------------------

As a reference/tribute to Jupyter, TeIDE was named after the first verified brown dwarf to be
[discovered](https://en.wikipedia.org/wiki/Teide_1).
